--[[
Static_Recharge's Combat Indicator. Refer to LICENSE and README.md for details
]]--

SRCI = {}
SRCI.ready = false

SRCI.Globals = {}
SRCI.Globals.inCombat = false
SRCI.Globals.stealthState = 0

SRCI.AddonID = "SRCI"
SRCI.AddonName = "SRCombatIndicator"
SRCI.AddonAbbrev = "SCI"
SRCI.Author = "Static_Recharge"
SRCI.AddonVersion = "0.5.2"

SRCIdefaults = 
{	
	stealthEnabled = false,
	debugEnabled = false,
	
	defaultColor = 
	{
		r = 255,
		b = 255,
		g = 255,
		a = 255
	},
	
	combatColor = 
	{
		r = 255,
		b = 0,
		g = 0,
		a = 255
	},
	
	stealthColor = 
	{
		r = 0,
		b = 0,
		g = 255,
		a = 255
	},
	
	warningColor = 
	{
		r = 255,
		b = 255,
		g = 0,
		a = 255
	}
}

function SRCI.StartUp()
	SRCISettingsMenu.StartUp()
end

function SRCI.SavedVariables()
	SavedVars = ZO_SavedVars:New("SRCIOptions", 0.6, nil, SRCIdefaults, nil)
	SRCI.ready = true
end

--Combat State
function SRCI.OnPlayerCombatState(_, inCombat)
	if SavedVars.debugEnabled then
		p("Combat event detected")
	end
  SRCI.Globals.inCombat = inCombat
end

--Stealth State
function SRCI.OnPlayerStealthState(_,_,stealthState)
	if SavedVars.debugEnabled then
		p("Stealth event detected")
	end
	SRCI.Globals.stealthState = stealthState
 end

function SRCI.SetCompassColor(color)
  ZO_CompassFrameLeft:SetColor(color.r, color.g, color.b, color.a)
  ZO_CompassFrameCenter:SetColor(color.r, color.g, color.b, color.a)
  ZO_CompassFrameRight:SetColor(color.r, color.g, color.b, color.a)
end

function SRCI.Update()
local color = formatColorTable(SRCIdefaults.defaultColor)
	if SRCI.ready then
		if SavedVars.stealthEnabled then
			if SRCI.Globals.stealthState == 5 then
				color = formatColorTable(SavedVars.warningColor)
			elseif SRCI.Globals.stealthState == 3 then
				color = formatColorTable(SavedVars.stealthColor)
			end
		end
		if SRCI.Globals.inCombat then
			color = formatColorTable(SavedVars.combatColor)
		end
	end
	SRCI.SetCompassColor(color)
end

SRCI.AddonReady, SRCI.AddonName, SRCI.AddonAbbrev, SRCI.AddonVersion, SRCI.AddonDescr = WF_RegisterFactory(SRCI.AddonName, SRCI)
WF_Event(EVENT_PLAYER_COMBAT_STATE, SRCI.OnPlayerCombatState)
WF_Event(EVENT_STEALTH_STATE_CHANGED, SRCI.OnPlayerStealthState)
