SRCISettingsMenu = {}
local LAM = LibStub("LibAddonMenu-1.0")

SRCISettingsMenu.StartUp = function() 
	local panel = LAM:CreateControlPanel("SRCISettingsPanel", "SR Combat Indicator Settings")
		
	-- Combat
	LAM:AddHeader(panel, "SRCICombatHeader", "Combat")
	LAM:AddColorPicker(panel, "SRCIInCombatColorPicker", "In Combat", nil, function() return getColor(SavedVars.combatColor) end,
	function(r, g, b, a) SavedVars.combatColor = setColor(r, g, b, a) end)
	
	-- Stealth
	LAM:AddHeader(panel, "SRCIStealthHeader", "Stealthed")
	LAM:AddCheckbox(panel, "SRCIStealthEnabledCheckBox", "Stealth Indicator", nil, function() return SavedVars.stealthEnabled end, function(stealthEnabled) SavedVars.stealthEnabled = stealthEnabled end)
	
	LAM:AddColorPicker(panel, "SRCIStealthedColorPicker", "Stealthed", nil, function() return getColor(SavedVars.stealthColor) end,
	function(r, g, b, a) SavedVars.stealthColor = setColor(r, g, b, a) end)	

	LAM:AddColorPicker(panel, "SRCIWarningColorPicker", "Warning", nil, function() return getColor(SavedVars.warningColor) end,
	function(r, g, b, a) SavedVars.warningColor = setColor(r, g, b, a) end)
	
	-- Debug
	LAM:AddHeader(panel, "SRCIDebugHeader", "Debug")
	LAM:AddCheckbox(panel, "SRCIDebugEnabledCheckBox", "Debug", nil, function() return SavedVars.debugEnabled end, function(debugEnabled) SavedVars.debugEnabled = debugEnabled end)
end

function getColor(inputColorTable)
	local r = inputColorTable.r / 255
	local g = inputColorTable.g / 255
	local b = inputColorTable.b / 255
	local a = inputColorTable.a / 255
	
	return r, g, b, a
end

function formatColorTable(inputColorTable)
local color = {}
	color.r = inputColorTable.r / 255
	color.g = inputColorTable.g / 255
	color.b = inputColorTable.b / 255
	color.a = inputColorTable.a / 255
	
	return color
end

function setColor(r, g, b, a)
local outputColorTable = {}
	outputColorTable.r = math.floor(r * 255)
	outputColorTable.g = math.floor(g * 255)
	outputColorTable.b = math.floor(b * 255)
	outputColorTable.a = math.floor(a * 255)
	
	return outputColorTable
end

--text = string; the text to display for this option
--tooltip = string; the tooltip text
--minValue = integer; the minimum value for the slider
--maxValue = integer; the maximum value for the slider
--step = integer; the incremental step size for the slider
--isMultiLine = boolean; make the editbox more than one line
--onClick = function; the function to execute when the button is clicked
--validChoices = table; choices to display in the dropdown
--getFunc = function; a function to return the current value (string) this option is set to
--setFunc = function; a function to save the new value this option is set to - passes through 1 argument, the new value (string)
--warning = boolean; display a warning icon for this option
--warningText = string; the tooltip text to display for the warning icon

